#include "son.h"

/*Include file for emhh.c to do FFT loadhh, i.e., qloadh*/
/*For long double (quad) precision*/

int *ni0,*mi0;

Rtyp *hre,*him,*hrez,*himz;
RRtyp *qhre,*qhim,*qhrez,*qhimz;

void qloadh(Box,Cyc)  Box_info *Box;  int Cyc;
/*************************************************************/
/* Load the H matrices using FFT.                            */
/* (C) COPYRIGHT 1988 JAMES C. RAUTIO.  ALL RIGHTS RESERVED. */
/*************************************************************/
/* jcr20sep88 */ 
/* jcr17feb89 modified for FFT*/
/* jcr26jul90 modified for unwound loops*/
/* jcr13jul92 modified for quad prec. option*/
{ int i,j,m,n,odd;
  int m0,m1,n0,n1;
  int mo,no;
  int ni,mi;
  RRtyp xi,xr;
  RRtyp *qhvec;

  /****** qclear_hh and hh_init MUST be called b4 calling this routine!!! ********/

  /*Do the qhh.mat load*/
  m = Capm2 + !mo_odd;
  n = Capn2 + !no_odd;
  if (xsym) n = ((!no_odd) && (!(Capn2&1))) + ((Capn2+1)>>1);
  qhim = (RRtyp *)cnew(m,sizeof(RRtyp));  qhimz = qhim + m - 1;
  if (loss) { qhre = (RRtyp *)cnew(m,sizeof(RRtyp));  qhrez = qhre + m - 1; }
  qhh.mat_im = (RRtyp *)cnew(m*n,sizeof(RRtyp));
  if (loss) qhh.mat_re = (RRtyp *)cnew(m*n,sizeof(RRtyp));
  qhh.m = m;  qhh.n = n;

/*Big Loop unwound and conditionals taken outside loop for speed*/
#include "qemha.c"

  sFree( (char *)qhim);  if (loss) sFree( (char *)qhre);
  for (i=0; i<qhh.m; i++)
  { qhvec = qhh.mat_im + qhh.n * i;
    qcs_fft(qhvec,gy,no_odd,xsym,Capn);
    if (qhh.mat_re)
    { qhvec = qhh.mat_re + qhh.n * i;
      qcs_fft(qhvec,gy,no_odd,xsym,Capn);
    }
  }
  /*Location (mo,no) is (row/2,col/2) indices in hh.mat*/

  /*Now do the M/2 vector*/
  if ( gx ^ mo_odd )
  { qhh.gNm_im = (RRtyp *)cnew(qhh.n,sizeof(RRtyp));
    if (loss) qhh.gNm_re = (RRtyp *)cnew(qhh.n,sizeof(RRtyp));
    for (ni=n0,n=1; ni<n1; ni++,n=xsym+( (ni)<<xsym ))
    { xi = 0.0;  xr = 0.0;
      for (i=0; i<Cyc; i++) for (j=0; j<Cyc; j++)
      { ffp( i*Capm+Capm2, j*Capn+n );
        odd = ( j*no_odd ) & 1;  if (!gx) odd = (i+odd)&1;
        xi += (odd) ? -ff_im : ff_im;  xr += (odd) ? -ff_re : ff_re;

        ffp( i*Capm+Capm2, (j+1)*Capn-n );
        odd = ( (j+1)*no_odd ) & 1;
        if (!gx) odd = (i+odd)&1;  if (!gy) odd = !odd;
        xi += (odd) ? -ff_im : ff_im;  xr += (odd) ? -ff_re : ff_re;
      }
      *(qhh.gNm_im + ni) = 0.25 * xi;
      if (loss) *(qhh.gNm_re + ni) = 0.25 * xr;
    }
    qcs_fft(qhh.gNm_im,gy,no_odd,xsym,Capn);
    if (qhh.gNm_re)
      qcs_fft(qhh.gNm_re,gy,no_odd,xsym,Capn);
  }

  /*Do the M=0 vector*/
  if (gx)
  { qhh.gN_im = (RRtyp *)cnew(qhh.n,sizeof(RRtyp));
    if (loss) qhh.gN_re = (RRtyp *)cnew(qhh.n,sizeof(RRtyp));
    for (ni=n0,n=1; ni<n1; ni++,n=xsym+( (ni)<<xsym ))
    { xi = 0.0;  xr = 0.0;
      for (i=0; i<Cyc; i++) for (j=0; j<Cyc; j++)
      { ffp( i*Capm, j*Capn+n );
        odd = ( i*mo_odd + j*no_odd ) & 1;
        xi += (odd) ? -ff_im : ff_im;  xr += (odd) ? -ff_re : ff_re;

        ffp( i*Capm, (j+1)*Capn-n );
        odd = ( i*mo_odd + (j+1)*no_odd ) & 1;
        if (!gy) odd = !odd;
        xi += (odd) ? -ff_im : ff_im;  xr += (odd) ? -ff_re : ff_re;
      }
      *(qhh.gN_im + ni) = 0.25 * xi;
      if (loss) *(qhh.gN_re + ni) = 0.25 * xr;
    }
    qcs_fft(qhh.gN_im,gy,no_odd,xsym,Capn);
    if (qhh.gN_re)
      qcs_fft(qhh.gN_re,gy,no_odd,xsym,Capn);
  }

  /*If xsym and N/2 is even, no more*/
  if (xsym && !(Capn2&1))
    return;

  /*Now do the N/2 vector*/
  if ( gy ^ no_odd )
  { qhh.gMn_im = (RRtyp *)cnew(qhh.m,sizeof(RRtyp));
    if (loss) qhh.gMn_re = (RRtyp *)cnew(qhh.m,sizeof(RRtyp));
    for (mi=m0; (m = mi)<m1; mi++)
    { xi = 0.0;  xr = 0.0;
      for (i=0; i<Cyc; i++) for (j=0; j<Cyc; j++)
      { ffp( i*Capm+m, j*Capn+Capn2 );
        odd = ( i*mo_odd ) & 1;  if (!gy) odd = (j+odd)&1;
        xi += (odd) ? -ff_im : ff_im;  xr += (odd) ? -ff_re : ff_re;

        ffp( (i+1)*Capm-m, j*Capn+Capn2 );
        odd = ( (i+1)*mo_odd ) & 1;
        if (!gy) odd = (j+odd)&1;  if (!gx) odd = !odd;
        xi += (odd) ? -ff_im : ff_im;  xr += (odd) ? -ff_re : ff_re;
      }
      *(qhh.gMn_im + m) = 0.25 * xi;
      if (loss) *(qhh.gMn_re + m) = 0.25 * xr;
    }
    qcs_fft(qhh.gMn_im,gx,mo_odd,0,Capm);
    if (qhh.gMn_re)
      qcs_fft(qhh.gMn_re,gx,mo_odd,0,Capm);
  }

  /*Do the N=0 portion*/
  if (gy && !xsym)
  { qhh.gM_im = (RRtyp *)cnew(qhh.m,sizeof(RRtyp));
    if (loss) qhh.gM_re = (RRtyp *)cnew(qhh.m,sizeof(RRtyp));
    for (mi=m0; (m = mi)<m1; mi++)
    { xi = 0.0;  xr = 0.0;
      for (i=0; i<Cyc; i++) for (j=0; j<Cyc; j++)
      { ffp( i*Capm+m, j*Capn );
        odd = ( i*mo_odd + j*no_odd ) & 1;
        xi += (odd) ? -ff_im : ff_im;  xr += (odd) ? -ff_re : ff_re;

        ffp( (i+1)*Capm-m, j*Capn);
        odd = ( (i+1)*mo_odd + j*no_odd ) & 1;
        if (!gx) odd = !odd;
        xi += (odd) ? -ff_im : ff_im;  xr += (odd) ? -ff_re : ff_re;
      }
      *(qhh.gM_im + m) = 0.25 * xi;
      if (loss) *(qhh.gM_re + m) = 0.25 * xr;
    }
    qcs_fft(qhh.gM_im,gx,mo_odd,0,Capm);
    if (qhh.gM_re)
      qcs_fft(qhh.gM_re,gx,mo_odd,0,Capm);
  }

  /*Do the m=M/2, n=N/2 term (if xsym and N/2 even, won't get this far)*/
  if ( ( gx^mo_odd ) && ( gy^no_odd ) )
  for (i=0; i<Cyc; i++) for (j=0; j<Cyc; j++)
  { ffp( i*Capm+Capm2, j*Capn+Capn2 );
    odd = 0;  if (!gx) odd = i&1;
    if (!gy) odd = (j+odd)&1;
    if (odd) { qhh.mn_im -= 0.25*ff_im;  qhh.mn_re -= 0.25*ff_re; }
    else     { qhh.mn_im += 0.25*ff_im;  qhh.mn_re += 0.25*ff_re; }
  }

  /*Do the m=0, n=N/2 term*/
  if ( gx && ( gy^no_odd ) ) for (i=0; i<Cyc; i++) for (j=0; j<Cyc; j++)
  { ffp( i*Capm, j*Capn+Capn2 );
    odd = (i*mo_odd) & 1;
    if (!gy) odd = (j+odd)&1;
    if (odd) { qhh.on_im -= 0.25*ff_im;  qhh.on_re -= 0.25*ff_re; }
    else     { qhh.on_im += 0.25*ff_im;  qhh.on_re += 0.25*ff_re; }
  }

  if (xsym) return;

  /*Do the m=M/2, n=0 term*/
  if ( gy && ( gx^mo_odd ) ) for (i=0; i<Cyc; i++) for (j=0; j<Cyc; j++)
  { ffp( i*Capm+Capm2, j*Capn );
    odd = (j*no_odd) & 1;
    if (!gx) odd = (i+odd)&1;
    if (odd) { qhh.mo_im -= 0.25*ff_im;  qhh.mo_re -= 0.25*ff_re; }
    else     { qhh.mo_im += 0.25*ff_im;  qhh.mo_re += 0.25*ff_re; }
  }

  /*Do the m=0, n=0 term*/
  if ( gx &&  gy) for (i=0; i<Cyc; i++) for (j=0; j<Cyc; j++) if (i!=0 || j!=0)
  { ffp( i*Capm, j*Capn );
    odd = (i*mo_odd + j*no_odd) & 1;
    if (odd) { qhh.oo_im -= 0.25*ff_im;  qhh.oo_re -= 0.25*ff_re; }
    else     { qhh.oo_im += 0.25*ff_im;  qhh.oo_re += 0.25*ff_re; }
  }
  return;
} /*qloadh*/ 

void loadh(Box,Cyc)  Box_info *Box;  int Cyc;
/*************************************************************/
/* Load the H matrices using FFT.                            */
/* (C) COPYRIGHT 1988 JAMES C. RAUTIO.  ALL RIGHTS RESERVED. */
/*************************************************************/
/* jcr20sep88 */ 
/* jcr17feb89 modified for FFT*/
/* jcr26jul90 modified for unwound loops*/
{ int i,j,m,n,odd;
  int mo,no;
  int *ni,*mi;
  Rtyp xi,xr;
  Rtyp *hvec;

  /****** hh_init MUST be called b4 calling this routine!!! ********/

  /*Do the hh.mat load*/
  m = Capm2 + !mo_odd;
  n = Capn2 + !no_odd;
  if (xsym) n = ((!no_odd) && (!(Capn2&1))) + ((Capn2+1)>>1);
  him = (Rtyp *)cnew(m,sizeof(Rtyp));  himz = him + m - 1;
  if (loss) { hre = (Rtyp *)cnew(m,sizeof(Rtyp));  hrez = hre + m - 1; }
  hh.mat_im = (Rtyp *)cnew(m*n,sizeof(Rtyp));
  if (loss) hh.mat_re = (Rtyp *)cnew(m*n,sizeof(Rtyp));
  hh.m = m;  hh.n = n;

/*Big Loop unwound and conditionals taken outside loop for speed*/
#include "emha.c"

  sFree( (char *)him);  if (loss) sFree( (char *)hre);
  for (i=0; i<hh.m; i++)
  { hvec = hh.mat_im + hh.n * i;
    hk_interp(hvec,ni0);
    cs_fft(hvec,gy,no_odd,xsym,Capn);
    if (hh.mat_re)
    { hvec = hh.mat_re + hh.n * i;
      hk_interp(hvec,ni0);
      cs_fft(hvec,gy,no_odd,xsym,Capn);
    }
  }
  /*Location (mo,no) is (row/2,col/2) indices in hh.mat*/

  /*Now do the M/2 vector*/
  if ( gx ^ mo_odd )
  { hh.gNm_im = (Rtyp *)cnew(hh.n,sizeof(Rtyp));
    if (loss) hh.gNm_re = (Rtyp *)cnew(hh.n,sizeof(Rtyp));
    for (ni=ni0,n=1; *ni>=0; ni++,n=xsym+( (*ni)<<xsym ))
    { xi = 0.0;  xr = 0.0;
      for (i=0; i<Cyc; i++) for (j=0; j<Cyc; j++)
      { ffp( i*Capm+Capm2, j*Capn+n );
        odd = ( j*no_odd ) & 1;  if (!gx) odd = (i+odd)&1;
        xi += (odd) ? -ff_im : ff_im;  xr += (odd) ? -ff_re : ff_re;

        ffp( i*Capm+Capm2, (j+1)*Capn-n );
        odd = ( (j+1)*no_odd ) & 1;
        if (!gx) odd = (i+odd)&1;  if (!gy) odd = !odd;
        xi += (odd) ? -ff_im : ff_im;  xr += (odd) ? -ff_re : ff_re;
      }
      *(hh.gNm_im + *ni) = 0.25 * xi;
      if (loss) *(hh.gNm_re + *ni) = 0.25 * xr;
    }
    hk_interp(hh.gNm_im,ni0);
    cs_fft(hh.gNm_im,gy,no_odd,xsym,Capn);
    if (hh.gNm_re)
    { hk_interp(hh.gNm_re,ni0);
      cs_fft(hh.gNm_re,gy,no_odd,xsym,Capn);
    }
  }

  /*Do the M=0 vector*/
  if (gx)
  { hh.gN_im = (Rtyp *)cnew(hh.n,sizeof(Rtyp));
    if (loss) hh.gN_re = (Rtyp *)cnew(hh.n,sizeof(Rtyp));
    for (ni=ni0,n=1; *ni>=0; ni++,n=xsym+( (*ni)<<xsym ))
    { xi = 0.0;  xr = 0.0;
      for (i=0; i<Cyc; i++) for (j=0; j<Cyc; j++)
      { ffp( i*Capm, j*Capn+n );
        odd = ( i*mo_odd + j*no_odd ) & 1;
        xi += (odd) ? -ff_im : ff_im;  xr += (odd) ? -ff_re : ff_re;

        ffp( i*Capm, (j+1)*Capn-n );
        odd = ( i*mo_odd + (j+1)*no_odd ) & 1;
        if (!gy) odd = !odd;
        xi += (odd) ? -ff_im : ff_im;  xr += (odd) ? -ff_re : ff_re;
      }
      *(hh.gN_im + *ni) = 0.25 * xi;
      if (loss) *(hh.gN_re + *ni) = 0.25 * xr;
    }
    hk_interp(hh.gN_im,ni0);
    cs_fft(hh.gN_im,gy,no_odd,xsym,Capn);
    if (hh.gN_re)
    { hk_interp(hh.gN_re,ni0);
      cs_fft(hh.gN_re,gy,no_odd,xsym,Capn);
    }
  }

  /*If xsym and N/2 is even, no more*/
  if (xsym && !(Capn2&1)) { sFree( (char *)mi0);  sFree( (char *)ni0);  return; }

  /*Now do the N/2 vector*/
  if ( gy ^ no_odd )
  { hh.gMn_im = (Rtyp *)cnew(hh.m,sizeof(Rtyp));
    if (loss) hh.gMn_re = (Rtyp *)cnew(hh.m,sizeof(Rtyp));
    for (mi=mi0; (m = *mi)>=0; mi++)
    { xi = 0.0;  xr = 0.0;
      for (i=0; i<Cyc; i++) for (j=0; j<Cyc; j++)
      { ffp( i*Capm+m, j*Capn+Capn2 );
        odd = ( i*mo_odd ) & 1;  if (!gy) odd = (j+odd)&1;
        xi += (odd) ? -ff_im : ff_im;  xr += (odd) ? -ff_re : ff_re;

        ffp( (i+1)*Capm-m, j*Capn+Capn2 );
        odd = ( (i+1)*mo_odd ) & 1;
        if (!gy) odd = (j+odd)&1;  if (!gx) odd = !odd;
        xi += (odd) ? -ff_im : ff_im;  xr += (odd) ? -ff_re : ff_re;
      }
      *(hh.gMn_im + m) = 0.25 * xi;
      if (loss) *(hh.gMn_re + m) = 0.25 * xr;
    }
    hk_interp(hh.gMn_im,mi0);
    cs_fft(hh.gMn_im,gx,mo_odd,0,Capm);
    if (hh.gMn_re)
    { hk_interp(hh.gMn_re,mi0);
      cs_fft(hh.gMn_re,gx,mo_odd,0,Capm);
    }
  }

  /*Do the N=0 portion*/
  if (gy && !xsym)
  { hh.gM_im = (Rtyp *)cnew(hh.m,sizeof(Rtyp));
    if (loss) hh.gM_re = (Rtyp *)cnew(hh.m,sizeof(Rtyp));
    for (mi=mi0; (m = *mi)>=0; mi++)
    { xi = 0.0;  xr = 0.0;
      for (i=0; i<Cyc; i++) for (j=0; j<Cyc; j++)
      { ffp( i*Capm+m, j*Capn );
        odd = ( i*mo_odd + j*no_odd ) & 1;
        xi += (odd) ? -ff_im : ff_im;  xr += (odd) ? -ff_re : ff_re;

        ffp( (i+1)*Capm-m, j*Capn);
        odd = ( (i+1)*mo_odd + j*no_odd ) & 1;
        if (!gx) odd = !odd;
        xi += (odd) ? -ff_im : ff_im;  xr += (odd) ? -ff_re : ff_re;
      }
      *(hh.gM_im + m) = 0.25 * xi;
      if (loss) *(hh.gM_re + m) = 0.25 * xr;
    }
    hk_interp(hh.gM_im,mi0);
    cs_fft(hh.gM_im,gx,mo_odd,0,Capm);
    if (hh.gM_re)
    { hk_interp(hh.gM_re,mi0);
      cs_fft(hh.gM_re,gx,mo_odd,0,Capm);
    }
  }

  /*Do the m=M/2, n=N/2 term (if xsym and N/2 even, won't get this far)*/
  if ( ( gx^mo_odd ) && ( gy^no_odd ) )
  for (i=0; i<Cyc; i++) for (j=0; j<Cyc; j++)
  { ffp( i*Capm+Capm2, j*Capn+Capn2 );
    odd = 0;  if (!gx) odd = i&1;
    if (!gy) odd = (j+odd)&1;
    if (odd) { hh.mn_im -= 0.25*ff_im;  hh.mn_re -= 0.25*ff_re; }
    else     { hh.mn_im += 0.25*ff_im;  hh.mn_re += 0.25*ff_re; }
  }

  /*Do the m=0, n=N/2 term*/
  if ( gx && ( gy^no_odd ) ) for (i=0; i<Cyc; i++) for (j=0; j<Cyc; j++)
  { ffp( i*Capm, j*Capn+Capn2 );
    odd = (i*mo_odd) & 1;
    if (!gy) odd = (j+odd)&1;
    if (odd) { hh.on_im -= 0.25*ff_im;  hh.on_re -= 0.25*ff_re; }
    else     { hh.on_im += 0.25*ff_im;  hh.on_re += 0.25*ff_re; }
  }

  sFree( (char *)mi0);  sFree( (char *)ni0);  /*Free the indices list*/

  if (xsym) return;

  /*Do the m=M/2, n=0 term*/
  if ( gy && ( gx^mo_odd ) ) for (i=0; i<Cyc; i++) for (j=0; j<Cyc; j++)
  { ffp( i*Capm+Capm2, j*Capn );
    odd = (j*no_odd) & 1;
    if (!gx) odd = (i+odd)&1;
    if (odd) { hh.mo_im -= 0.25*ff_im;  hh.mo_re -= 0.25*ff_re; }
    else     { hh.mo_im += 0.25*ff_im;  hh.mo_re += 0.25*ff_re; }
  }

  /*Do the m=0, n=0 term*/
  if ( gx &&  gy) for (i=0; i<Cyc; i++) for (j=0; j<Cyc; j++) if (i!=0 || j!=0)
  { ffp( i*Capm, j*Capn );
    odd = (i*mo_odd + j*no_odd) & 1;
    if (odd) { hh.oo_im -= 0.25*ff_im;  hh.oo_re -= 0.25*ff_re; }
    else     { hh.oo_im += 0.25*ff_im;  hh.oo_re += 0.25*ff_re; }
  }
  return;
} /*loadh*/ 

void ff_xx(m,n)  int m,n;
/*************************************************************/
/* Calculate ff for x to x coupling only.                    */
/* (C) COPYRIGHT 1989 JAMES C. RAUTIO.  ALL RIGHTS RESERVED. */
/*************************************************************/
/* jcr21feb89 */ 
{ Rtyp  kx,ky,kc,kx_sqr,ky_sqr,kc_sqr;
  Rtyp Zte,Ztm;
  int loc;

  /*Calculate mode specific constants.*/
  kx = m*Piova;  ky = n*Piovb;
  kx_sqr = kx * kx;  ky_sqr = ky * ky;

  if (m<maxm && n<maxn)
  { loc = m + ( n>>xsym ) * maxm;
    Zte = *(Zte_vec_im + loc);  Ztm = *(Ztm_vec_im + loc);
  }
  else
  { kc_sqr = kx_sqr + ky_sqr;  kc = sqrt(kc_sqr);
    loc = (int)( terp_a + terp_b/kc );
    Ztm = *(tm_im_a0+loc) + kc_sqr * ( *(tm_im_a1+loc) + kc_sqr * ( *(tm_im_a2+loc) +
                            kc_sqr * *(tm_im_a3+loc) ) );
    Zte = *(te_im_a0+loc) + ( *(te_im_a1+loc) + ( *(te_im_a2+loc) +  
                            *(te_im_a3+loc)/kc_sqr )/kc_sqr )/kc_sqr;
  }

  /*Do coupling from x to x directed current*/
  /*ff_im = - Gxx * (N1_sqr * Zte + N2_sqr * Ztm);*/
  ff_im = *(garrm+m) * *(garrn+n) * ( ky_sqr * Zte + kx_sqr * Ztm );
  if (m==0 || n==0) ff_im *= 0.5;

  ff_re = 0.0;  /*Do real part if needed*/
  if (!loss) return;
  if (m<maxm && n<maxn)
  { Zte = *(Zte_vec_re + loc);  Ztm = *(Ztm_vec_re + loc); }
  else
  { Ztm = *(tm_re_a0+loc) + kc_sqr * ( *(tm_re_a1+loc) + kc_sqr * ( *(tm_re_a2+loc) +
                            kc_sqr * *(tm_re_a3+loc) ) );
    Zte = *(te_re_a0+loc) + ( *(te_re_a1+loc) + ( *(te_re_a2+loc) +
                            *(te_re_a3+loc)/kc_sqr )/kc_sqr )/kc_sqr;
  }

  /*Do coupling from x to x directed current*/
  /*ff_re = - Gxx * (N1_sqr * Zte + N2_sqr * Ztm);*/
  ff_re = *(garrm+m) * *(garrn+n) * ( ky_sqr * Zte + kx_sqr * Ztm );
  if (m==0 || n==0) ff_re *= 0.5;

} /*ff_xx*/

void ff_xy(m,n)  int m,n;
/*************************************************************/
/* Calculate ff for x to y coupling only.                    */
/* (C) COPYRIGHT 1989 JAMES C. RAUTIO.  ALL RIGHTS RESERVED. */
/*************************************************************/
/* jcr21feb89 */ 
{ Rtyp  kx,ky,kc,kc_sqr;
  Rtyp Zdiff;
  int loc;

  if (m==0 || n==0) { ff_im=0.0;  ff_re=0.0;  return; }
  /*Calculate mode specific constants.*/
  kx = m*Piova;  ky = n*Piovb;

  if (m<maxm && n<maxn)
  { loc = m + ( n>>xsym ) * maxm;
    Zdiff = *(Ztm_vec_im + loc);
  }
  else
  { kc_sqr = kx*kx + ky*ky;  kc = sqrt(kc_sqr);
    loc = (int)( terp_a + terp_b/kc );
    Zdiff = *(tm_im_a0+loc) + kc_sqr * ( *(tm_im_a1+loc) + kc_sqr * ( *(tm_im_a2+loc) +
                              kc_sqr * *(tm_im_a3+loc) ) );
  }

  /*Do coupling from x to x directed current*/
  /*ff_im = Gxy * N1N2 * (Zte - Ztm);*/
  ff_im = *(garrm+m) * *(garrn+n) * Zdiff;

  ff_re = 0.0;  /*Do real part if needed*/
  if (!loss) return;
  if (m<maxm && n<maxn)
    Zdiff = *(Ztm_vec_re + loc);
  else
    Zdiff = *(tm_re_a0+loc) + kc_sqr * ( *(tm_re_a1+loc) + kc_sqr * ( *(tm_re_a2+loc) +
                              kc_sqr * *(tm_re_a3+loc) ) );

  /*Do coupling from x to x directed current*/
  /*ff_re = Gxy * N1N2 * (Zte - Ztm);*/
  ff_re = *(garrm+m) * *(garrn+n) * Zdiff;

} /*ff_xy*/

void ff_yy(m,n)  int m,n;
/*************************************************************/
/* Calculate ff for y to y coupling only.                    */
/* (C) COPYRIGHT 1989 JAMES C. RAUTIO.  ALL RIGHTS RESERVED. */
/*************************************************************/
/* jcr21feb89 */ 
{ Rtyp  kx,ky,kc,kx_sqr,ky_sqr,kc_sqr;
  Rtyp Zte,Ztm;
  int loc;

  /*Calculate mode specific constants.*/
  kx = m*Piova;  ky = n*Piovb;
  kx_sqr = kx * kx;  ky_sqr = ky * ky;

  if (m<maxm && n<maxn)
  { loc = m + ( n>>xsym ) * maxm;
    Zte = *(Zte_vec_im + loc);  Ztm = *(Ztm_vec_im + loc);
  }
  else
  { kc_sqr = kx_sqr + ky_sqr;  kc = sqrt(kc_sqr);
    loc = (int)( terp_a + terp_b/kc );
    Ztm = *(tm_im_a0+loc) + kc_sqr * ( *(tm_im_a1+loc) + kc_sqr * ( *(tm_im_a2+loc) +
                            kc_sqr * *(tm_im_a3+loc) ) );
    Zte = *(te_im_a0+loc) + ( *(te_im_a1+loc) + ( *(te_im_a2+loc) +  
                            *(te_im_a3+loc)/kc_sqr )/kc_sqr )/kc_sqr;
  }

  /*Do coupling from x to x directed current*/
  /*ff_im = - Gyy * (N1_sqr * Ztm + N2_sqr * Zte);*/
  ff_im = *(garrm+m) * *(garrn+n) * ( ky_sqr * Ztm + kx_sqr * Zte );
  if (m==0 || n==0) ff_im *= 0.5;

  ff_re = 0.0;  /*Do real part if needed*/
  if (!loss) return;
  if (m<maxm && n<maxn)
  { Zte = *(Zte_vec_re + loc);  Ztm = *(Ztm_vec_re + loc); }
  else
  { Ztm = *(tm_re_a0+loc) + kc_sqr * ( *(tm_re_a1+loc) + kc_sqr * ( *(tm_re_a2+loc) +
                            kc_sqr * *(tm_re_a3+loc) ) );
    Zte = *(te_re_a0+loc) + ( *(te_re_a1+loc) + ( *(te_re_a2+loc) +
                            *(te_re_a3+loc)/kc_sqr )/kc_sqr )/kc_sqr;
  }

  /*Do coupling from x to x directed current*/
  /*ff_re = - Gxx * (N1_sqr * Zte + N2_sqr * Ztm);*/
  ff_re = *(garrm+m) * *(garrn+n) * ( ky_sqr * Ztm + kx_sqr * Zte );
  if (m==0 || n==0) ff_re *= 0.5;

} /*ff_yy*/

void xrfxrf_init(dx,dy,gm_len,gn_len,gm,gn)  Rtyp dx,dy,*gm,*gn;  int gm_len,gn_len;
/*************************************************************/
/* Initialize the gm and gn arrays for x to x roof coupling. */
/* (C) COPYRIGHT 1988 JAMES C. RAUTIO.  ALL RIGHTS RESERVED. */
/*************************************************************/
/* jcr21feb89 */ 
{ int m,n;
  Rtyp kx,ky,dxkx;

  *gm = - 4.0*dx*dx; /*sign so ff won't have to do it.*/
  for (gm++,m=1; m<gm_len; m++,gm++)
  { kx = m * Piova;  dxkx = dx * kx;
    *gm = (1.0 - cos(dxkx + dxkx)) / (dxkx * kx);
    *gm *=  - *gm;  /*x to x means we sqr it*/
  }

  *gn = 4.0*dy*dy;
  for (gn++,n=1; n<gn_len; n++,gn++)
  { ky = n * Piovb;
    *gn = sin(ky*dy)/ky;  *gn += *gn;  *gn *= *gn;
  }
} /*xrfxrf_init*/

void yrfyrf_init(dx,dy,gm_len,gn_len,gm,gn)  Rtyp dx,dy,*gm,*gn;  int gm_len,gn_len;
/*************************************************************/
/* Initialize the gm and gn arrays for y to y roof coupling. */
/* (C) COPYRIGHT 1988 JAMES C. RAUTIO.  ALL RIGHTS RESERVED. */
/*************************************************************/
/* jcr21feb89 */ 
{ int m,n;
  Rtyp kx,ky,dyky;

  *gn = - 4.0*dy*dy; /*sign so ff won't have to do it.*/
  for (gn++,n=1; n<gn_len; n++,gn++)
  { ky = n * Piovb;  dyky = dy * ky;
    *gn = (1.0 - cos(dyky + dyky)) / (dyky * ky);
    *gn *=  - *gn;  /*y to y means we sqr it*/
  }

  *gm = 4.0*dx*dx;
  for (gm++,m=1; m<gm_len; m++,gm++)
  { kx = m * Piova;
    *gm = sin(kx*dx)/kx;  *gm += *gm;  *gm *= *gm;
  }
} /*yrfyrf_init*/

void xrfyrf_init(dx,dy,gm_len,gn_len,gm,gn)  Rtyp dx,dy,*gm,*gn;  int gm_len,gn_len;
/*************************************************************/
/* Initialize the gm and gn arrays for x to y roof coupling. */
/* (C) COPYRIGHT 1988 JAMES C. RAUTIO.  ALL RIGHTS RESERVED. */
/*************************************************************/
/* jcr21feb89 */ 
{ int m,n;
  Rtyp kx,ky,dxkx,dyky;

  *gm = 0.0;
  for (gm++,m=1; m<gm_len; m++,gm++)
  { kx = m * Piova;  dxkx = dx * kx;
    *gm = sin(kx*dx)/kx;  *gm += *gm;
    /* dxkx*kx -> dxkx because one cancels with kx in N1N2 */
    *gm *= (1.0 - cos(dxkx + dxkx)) / dxkx;
  }

  *gn = 0.0;
  for (gn++,n=1; n<gn_len; n++,gn++)
  { ky = n * Piovb;  dyky = dy*ky;
    *gn = sin(dyky)/ky;  *gn += *gn;
    /* dyky*ky -> dyky because one cancels with ky in N1N2 */
    *gn *= (1.0 - cos(dyky + dyky)) / dyky;
  }
} /*xrfyrf_init*/
